import java.util.Arrays;

import fr.esrf.Tango.DevError;
import fr.esrf.Tango.DevFailed;
import fr.esrf.TangoApi.CallBack;
import fr.esrf.TangoApi.DevicePipe;
import fr.esrf.TangoApi.DeviceProxy;
import fr.esrf.TangoApi.events.EventData;
import fr.esrf.TangoDs.TangoConst;

public class MultipleClientThread extends CallBack implements Runnable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public MultipleClientThread() {
		// TODO Auto-generated constructor stub
	}
	
	MultipleClientThread obj;
	
	void printErrors(DevError[] errs) {
		for (int i = 0; i < errs.length; i++) {
			System.out.println("Error " + (i + 1) + " Description: " + errs[i].desc + " Severity: " + errs[i].severity.toString()
					+ " Reason: " + errs[i].reason + " Origin: " + errs[i].origin);
		}
	}
	
	@Override
	public void push_event(EventData evt) {
		System.out.println("In " + "push_event");
		System.out.println("Value of event source :- " + evt.device.fullName());
		if (!evt.err) {
			try {
				String[] eventResponse = evt.attr_value.extractStringArray();
				System.out.println("Value of Event received  :- " + Arrays.toString(eventResponse));
				/*System.out.println("eventResponse[0] :- " + eventResponse[0]);
				System.out.println("eventResponse[4] :- " + eventResponse[4]);*/
				
			} catch (DevFailed e) {
				// printErrors(e.errors);
				System.out.println("Subscribe event error in power equalisation thread :- "+ e);
				e.printStackTrace();
			} catch (Exception e) {
				System.out.println("Exception"+ e);
				e.printStackTrace();
			}
		} else {
			System.out.println("Event Data has errors");
			printErrors(evt.errors);
		}
		System.out.println("Out " + "push_event");
	}
	
	@Override
	public void run() {
		// TODO Auto-generated method stub
		obj = new MultipleClientThread();
		int eventId = 0;
		try{
			DeviceProxy dev =  new DeviceProxy("tango://01hw499468:10000/a/b/c");
			eventId = dev.subscribe_event("responseField", TangoConst.CHANGE_EVENT,obj, new String[0], true);
			System.out.println("eventId :- " + eventId);
			
			System.out.println("Event subscribed");
		}catch(DevFailed e){
			System.out.println("Devfailed exception occured");
			e.printStackTrace();
		}catch(Exception e){
			System.out.println("Exception caught" + e);
			e.printStackTrace();
		}
		while(true){
			
		}
	}

}
